property UpCM, HiliteCM, DownCM, UpSound, button_active

on mouseDown me
  set the member of sprite the spriteNum of me to member the DownCM of me
  set the button_active of me to 1
end

on mouseUp me
  set the member of sprite the currentSpriteNum to member the HiliteCM of me
  set the button_active of me to 0
  puppetSound(1, the UpSound of me)
end

on mouseEnter me
  if the button_active of me then
    set the member of sprite the spriteNum of me to member the DownCM of me
  else
    set the member of sprite the spriteNum of me to member the HiliteCM of me
  end if
end

on mouseLeave me
  set the member of sprite the spriteNum of me to member the UpCM of me
end

on mouseUpOutSide me
  set the member of sprite the spriteNum of me to member the UpCM of me
  set the button_active of me to 0
end

on beginSprite me
  if not (the UpCM of me) then
    set the UpCM of me to the member of sprite the spriteNum of me
  end if
  set the button_active of me to 0
  puppetSprite(the spriteNum of me, 1)
end

on endSprite me
  puppetSprite(the spriteNum of me, 0)
end

on getPropertyDescriptionList
  set p_list to [#UpCM: [#comment: "Normal Image:", #format: #member, #default: member 1], #HiliteCM: [#comment: "Hilite Image:", #format: #member, #default: member 1], #DownCM: [#comment: "Down Image:", #format: #member, #default: member 1], #UpSound: [#comment: "Sound for Release:", #format: #member, #default: member 1]]
  return p_list
end

on getBehaviorDescription
  return "Prepares a sprite for use as a Pushbutton with automatic highlighting, button depression, button sound and mouse tracking. If the Normal Image parameter value is 0, the sprite's initial castmember will be assumed represent the button's normal state." & RETURN & "PARAMETERS:" & RETURN & "• Normal Image - ( optional ) number of castmember providing image displayed when button is NOT pressed." & RETURN & "• Hilite Image - number of castmember providing image displayed when button is rolled over." & RETURN & "• Down Image - number of castmember providing image displayed when button is pressed." & RETURN & "• Button Up Sound - number of castmember providing sound for button release."
end
