global BODY_CH, HEAD_CH, HAT_CH, TEMP_CHANNEL, FIRST_FACE_CH, FIRST_STICKER_CH, PREV_FACE_CH, NEXT_FACE_CH, BIG_REFX, BIG_REFY, LETTER_PAGE, NUMBER_PAGE, GRAB_CH, FIRST_BODY_CH, MAX_BODY_CHS, MAX_BODIES, MAX_HEADS, MAX_HATS, MAX_FACE_PIECES, MAX_STICKER_PAGE, MAX_POSTERS, MISC_SOUND_CAST, LETTER_SOUND_CAST, NUMBER_SOUND_CAST, glstFace, glstMisc, gnNumPieces, glstFaces, gnPoster, gnBody, gnHead, gnHat, Poster.Body, Poster.Head, Poster.Hat, glstStickerPages, gnStickerPage, grectStickerArea, grectPosterArea, gnMidiLength, gbFirstTimePoster

on prepareMovie
  set the exitLock to 1
  set the keyDownScript to "TrapForDemo"
end

on MiscSound nSound
  if nSound = 0 then
    set nSound to random(41) + MISC_SOUND_CAST - 1
  end if
  puppetSound(the name of cast nSound)
  return nSound
end

on PickupSound me, nSound
  if gnStickerPage = LETTER_PAGE then
    return LetterSound(me)
  else
    if gnStickerPage = NUMBER_PAGE then
      return NumberSound(me)
    else
      return MiscSound(nSound)
    end if
  end if
end

on PlaceSound nSound
  return MiscSound(nSound)
end

on LetterSound me
  set nIndex to the spriteNum of me - FIRST_STICKER_CH
  set nSound to LETTER_SOUND_CAST + nIndex
  puppetSound(the name of cast nSound)
  return nSound
end

on NumberSound me
  set nIndex to the spriteNum of me - FIRST_STICKER_CH
  set nSound to NUMBER_SOUND_CAST + nIndex
  puppetSound(the name of cast nSound)
  return nSound
end

on startMovie
  FirstStartMovie()
  set LETTER_PAGE to 18
  set NUMBER_PAGE to 19
  set FIRST_STICKER_CH to 10
  set FIRST_BODY_CH to 19
  set PREV_FACE_CH to 46
  set NEXT_FACE_CH to 47
  set GRAB_CH to 120
  set MAX_BODIES to 9
  set MAX_HEADS to 12
  set MAX_HATS to 15
  set MAX_PIRATES to 12
  set MAX_MISC to 43
  set MAX_LETTERS to 27
  set MAX_STICKER_PAGE to 32
  set MAX_POSTERS to 5
  set MISC_SOUND_CAST to the number of member "MiscSound"
  set LETTER_SOUND_CAST to the number of member "sndStartLetter"
  set NUMBER_SOUND_CAST to the number of member "sndStartNumber"
  if voidp(gbFirstTimePoster) then
    set gbFirstTimePoster to 1
  end if
  if voidp(glstFaces) then
    set glstFaces to []
    set glstFace to []
    set gnBody to 0
    set gnHead to 0
    set gnHat to 0
    set gnMisc to -1
    set gnLetter to -1
    set gnPoster to 1
    set gnNumPieces to 0
  end if
  preloadMember(member "StartBody", member "EndBody")
  preloadMember(member "StartHead", member "EndHead")
  preloadMember(member "StartHat", member "EndHat")
  set glstStickerPages to ["ShowEyes1", "ShowEyes2", "ShowEyes3", "ShowEyes4", "ShowNoses", "ShowMouths", "ShowEars", "ShowBaldies", "ShowHair1", "ShowHair2", "ShowHair3", "ShowHair4", "ShowHands", "ShowBadges", "ShowInsects", "ShowProps", "ShowFrames", "ShowLetters", "ShowNumbers"]
  set gnStickerPage to 1
  set grectStickerArea to rect(38, 29, 259, 334)
  set grectPosterArea to rect(306, 8, 630, 476)
end

on stopMovie
  if the platform = "Windows,32" then
    mci("stop MidiFile")
    mci("close MidiFile")
  else
    sound stop 4
    puppetSound(4, 0)
  end if
  SharedStopMovie()
end

on InitMidi
  if the platform = "Windows,32" then
    set strFileName to "mountn.mid"
    set strTemp to "open" && strFileName && "alias MidiFile"
    mci(strTemp)
    mci("status MidiFile length")
    set gnMidiLength to the result
    mci("seek MidiFile to start")
    set strTemp to "play MidiFile to" && gnMidiLength
    mci(strTemp)
  else
    puppetSound(4, "sndMusicLoop")
  end if
end

on MidiLoop
  if the platform = "Windows,32" then
    mci("status MidiFile position")
    set nMidiPos to value(the result)
    if nMidiPos >= gnMidiLength then
      set strTemp1 to "play MidiFile to" && gnMidiLength
      mci("seek MidiFile to start")
      mci(strTemp1)
    end if
  end if
end

on AddToFace
  if inside(the loc of sprite GRAB_CH, grectPosterArea) then
    MoveItemsDown(FIRST_FACE_CH)
    set gnNumPieces to gnNumPieces + 1
    set the member of sprite (FIRST_FACE_CH + MAX_FACE_PIECES - 1) to the member of sprite GRAB_CH
    set the loc of sprite (FIRST_FACE_CH + MAX_FACE_PIECES - 1) to the loc of sprite GRAB_CH
  else
  end if
  set the member of sprite GRAB_CH to member "NullCast"
  set the loc of sprite GRAB_CH to point(-1000, -1000)
  updateStage()
end

on ClearFace
  repeat with i = FIRST_FACE_CH to FIRST_FACE_CH + MAX_FACE_PIECES - 1
    set the member of sprite i to member "NullCast"
    set the loc of sprite i to point(320, 240)
  end repeat
  set gnNumPieces to 0
end

on DisplayStickerPage lstStickers
  repeat with i = 1 to MAX_STICKER_PAGE
    puppetSprite(FIRST_STICKER_CH + i - 1, 1)
    if i <= count(lstStickers) then
      set the member of sprite (FIRST_STICKER_CH + i - 1) to getAt(getAt(lstStickers, i), 1)
      set the rect of sprite (FIRST_STICKER_CH + i - 1) to getAt(getAt(lstStickers, i), 2)
      next repeat
    end if
    set the member of sprite (FIRST_STICKER_CH + i - 1) to member "NullCast"
  end repeat
end

on DragItem me
  repeat while the mouseDown
    MidiLoop()
    set the loc of sprite GRAB_CH to point(the mouseH, the mouseV)
    updateStage()
  end repeat
  AddToFace()
end

on MoveItemsDown nStartChannel
  repeat with i = nStartChannel to FIRST_FACE_CH + MAX_FACE_PIECES - 2
    set the member of sprite i to the member of sprite (i + 1)
    set the loc of sprite i to the loc of sprite (i + 1)
  end repeat
end

on MoveItemsUP nStartChannel
  repeat with i = nStartChannel down to FIRST_FACE_CH + 1
    set the member of sprite i to the member of sprite (i - 1)
    set the loc of sprite i to the loc of sprite (i - 1)
  end repeat
end

on ResetPoster
  ClearFace()
  set gnNumPieces to 0
  set gnBody to 0
  set gnHead to 0
  set gnHat to 0
  set the member of sprite HAT_CH to member "NullCast"
  set the member of sprite HEAD_CH to member "NullCast"
  set the member of sprite BODY_CH to member "NullCast"
end

on SaveFace nPoster
  set lstItems to []
  repeat with i = FIRST_FACE_CH to FIRST_FACE_CH + MAX_FACE_PIECES - 1
    add(lstItems, [the member of sprite i, point(the locH of sprite i - BIG_REFX, the locV of sprite i - BIG_REFY)])
  end repeat
  set lstFace to []
  add(lstFace, the member of sprite HAT_CH)
  add(lstFace, the member of sprite HEAD_CH)
  add(lstFace, the member of sprite BODY_CH)
  add(lstFace, lstItems)
  add(lstFace, gnNumPieces)
  if nPoster > count(glstFaces) then
    add(glstFaces, lstFace)
  else
    setAt(glstFaces, nPoster, lstFace)
  end if
end

on ShowNoses
  set lstStickers to [[member 7 of castLib 3, rect(70, 90, 115, 113)], [member 8 of castLib 3, rect(149, 88, 215, 122)], [member 9 of castLib 3, rect(34, 116, 88, 160)], [member 10 of castLib 3, rect(217, 97, 267, 136)], [member 11 of castLib 3, rect(114, 162, 158, 202)], [member 12 of castLib 3, rect(158, 125, 205, 172)], [member 13 of castLib 3, rect(80, 203, 127, 233)], [member 14 of castLib 3, rect(225, 144, 268, 194)], [member 15 of castLib 3, rect(154, 218, 198, 256)], [member 16 of castLib 3, rect(38, 227, 89, 257)], [member 17 of castLib 3, rect(50, 261, 98, 316)], [member 18 of castLib 3, rect(229, 225, 279, 252)], [member 19 of castLib 3, rect(241, 338, 264, 351)], [member 20 of castLib 3, rect(233, 306, 278, 331)], [member 21 of castLib 3, rect(39, 320, 79, 352)], [member 22 of castLib 3, rect(191, 330, 230, 367)], [member 23 of castLib 3, rect(104, 239, 151, 274)], [member 24 of castLib 3, rect(182, 255, 221, 286)], [member 25 of castLib 3, rect(120, 287, 169, 330)], [member 26 of castLib 3, rect(78, 337, 168, 368)], [member 27 of castLib 3, rect(163, 171, 201, 211)], [member 28 of castLib 3, rect(179, 296, 211, 324)], [member 29 of castLib 3, rect(47, 170, 94, 205)], [member 30 of castLib 3, rect(243, 258, 277, 295)], [member 31 of castLib 3, rect(207, 191, 244, 223)], [member 32 of castLib 3, rect(97, 117, 140, 152)]]
  DisplayStickerPage(lstStickers)
end

on ShowMouths
  set lstStickers to [[member 33 of castLib 3, rect(111, 91, 142, 136)], [member 34 of castLib 3, rect(37, 269, 83, 313)], [member 35 of castLib 3, rect(30, 221, 86, 253)], [member 36 of castLib 3, rect(105, 240, 144, 275)], [member 37 of castLib 3, rect(95, 268, 144, 309)], [member 38 of castLib 3, rect(55, 324, 103, 362)], [member 39 of castLib 3, rect(214, 330, 261, 366)], [member 40 of castLib 3, rect(160, 191, 209, 226)], [member 42 of castLib 3, rect(125, 319, 149, 370)], [member 43 of castLib 3, rect(49, 150, 115, 178)], [member 44 of castLib 3, rect(227, 274, 270, 318)], [member 45 of castLib 3, rect(165, 237, 202, 272)], [member 46 of castLib 3, rect(151, 284, 210, 318)], [member 47 of castLib 3, rect(137, 141, 190, 179)], [member 48 of castLib 3, rect(144, 105, 199, 132)], [member 49 of castLib 3, rect(209, 86, 251, 131)], [member 50 of castLib 3, rect(212, 243, 261, 271)], [member 51 of castLib 3, rect(220, 187, 272, 227)], [member 52 of castLib 3, rect(32, 175, 74, 207)], [member 53 of castLib 3, rect(167, 330, 202, 361)], [member 220 of castLib 3, rect(48, 94, 99, 139)], [member 221 of castLib 3, rect(213, 146, 266, 175)], [member 222 of castLib 3, rect(81, 195, 157, 222)]]
  DisplayStickerPage(lstStickers)
end

on ShowEyes1
  set lstStickers to [[member 88 of castLib 3, rect(34, 135, 82, 172)], [member 89 of castLib 3, rect(96, 137, 144, 174)], [member 90 of castLib 3, rect(31, 320, 88, 357)], [member 91 of castLib 3, rect(97, 324, 154, 361)], [member 92 of castLib 3, rect(161, 321, 208, 350)], [member 93 of castLib 3, rect(218, 320, 265, 349)], [member 94 of castLib 3, rect(163, 97, 207, 137)], [member 95 of castLib 3, rect(220, 97, 264, 137)], [member 96 of castLib 3, rect(166, 214, 206, 253)], [member 97 of castLib 3, rect(228, 213, 268, 252)], [member 98 of castLib 3, rect(44, 182, 87, 218)], [member 99 of castLib 3, rect(110, 185, 153, 221)], [member 100 of castLib 3, rect(170, 154, 206, 195)], [member 101 of castLib 3, rect(228, 154, 264, 195)], [member 102 of castLib 3, rect(45, 97, 81, 133)], [member 103 of castLib 3, rect(91, 97, 127, 134)], [member 104 of castLib 3, rect(159, 272, 206, 304)], [member 105 of castLib 3, rect(222, 270, 269, 302)], [member 106 of castLib 3, rect(49, 224, 88, 272)], [member 107 of castLib 3, rect(101, 226, 140, 274)], [member 108 of castLib 3, rect(42, 275, 82, 318)], [member 109 of castLib 3, rect(99, 275, 139, 318)]]
  DisplayStickerPage(lstStickers)
end

on ShowEyes2
  set lstStickers to [[member 130 of castLib 3, rect(68, 98, 92, 151)], [member 131 of castLib 3, rect(108, 99, 132, 152)], [member 132 of castLib 3, rect(61, 161, 89, 217)], [member 133 of castLib 3, rect(106, 163, 134, 219)], [member 134 of castLib 3, rect(33, 269, 90, 297)], [member 135 of castLib 3, rect(101, 271, 158, 299)], [member 136 of castLib 3, rect(40, 228, 85, 257)], [member 137 of castLib 3, rect(105, 230, 150, 259)], [member 138 of castLib 3, rect(58, 312, 87, 353)], [member 139 of castLib 3, rect(107, 312, 136, 353)], [member 140 of castLib 3, rect(155, 117, 211, 149)], [member 141 of castLib 3, rect(215, 117, 271, 149)], [member 142 of castLib 3, rect(163, 300, 206, 355)], [member 143 of castLib 3, rect(222, 304, 265, 359)], [member 144 of castLib 3, rect(226, 176, 259, 219)], [member 145 of castLib 3, rect(173, 173, 206, 216)], [member 146 of castLib 3, rect(172, 230, 212, 279)], [member 147 of castLib 3, rect(224, 234, 264, 283)]]
  DisplayStickerPage(lstStickers)
end

on ShowEyes3
  set lstStickers to [[member 110 of castLib 3, rect(48, 320, 80, 365)], [member 111 of castLib 3, rect(94, 322, 126, 367)], [member 112 of castLib 3, rect(180, 314, 205, 371)], [member 113 of castLib 3, rect(227, 317, 252, 374)], [member 114 of castLib 3, rect(40, 212, 79, 257)], [member 115 of castLib 3, rect(93, 212, 132, 257)], [member 116 of castLib 3, rect(53, 156, 85, 195)], [member 117 of castLib 3, rect(95, 157, 127, 196)], [member 118 of castLib 3, rect(41, 264, 81, 311)], [member 119 of castLib 3, rect(99, 265, 139, 312)], [member 128 of castLib 3, rect(45, 98, 84, 147)], [member 121 of castLib 3, rect(223, 102, 268, 131)], [member 120 of castLib 3, rect(171, 102, 216, 131)], [member 123 of castLib 3, rect(237, 157, 253, 173)], [member 122 of castLib 3, rect(192, 156, 208, 172)], [member 124 of castLib 3, rect(174, 185, 220, 252)], [member 125 of castLib 3, rect(227, 185, 273, 252)], [member 110 of castLib 3, rect(183, 258, 216, 305)], [member 111 of castLib 3, rect(229, 259, 262, 306)], [member 129 of castLib 3, rect(88, 98, 127, 147)]]
  DisplayStickerPage(lstStickers)
end

on ShowEyes4
  set lstStickers to [[member 148 of castLib 3, rect(165, 290, 202, 353)], [member 149 of castLib 3, rect(218, 289, 255, 352)], [member 150 of castLib 3, rect(39, 156, 99, 194)], [member 151 of castLib 3, rect(107, 154, 169, 192)], [member 152 of castLib 3, rect(181, 108, 204, 159)], [member 153 of castLib 3, rect(224, 108, 247, 159)], [member 154 of castLib 3, rect(48, 102, 91, 144)], [member 155 of castLib 3, rect(100, 101, 143, 143)], [member 156 of castLib 3, rect(57, 317, 96, 367)], [member 157 of castLib 3, rect(114, 319, 140, 364)], [member 160 of castLib 3, rect(59, 205, 83, 236)], [member 161 of castLib 3, rect(110, 211, 138, 234)], [member 162 of castLib 3, rect(51, 263, 83, 327)], [member 163 of castLib 3, rect(109, 265, 137, 288)], [member 164 of castLib 3, rect(170, 180, 210, 255)], [member 165 of castLib 3, rect(215, 200, 263, 257)]]
  DisplayStickerPage(lstStickers)
end

on ShowEars
  set lstStickers to [[member 54 of castLib 3, rect(52, 98, 72, 142)], [member 55 of castLib 3, rect(79, 99, 99, 143)], [member 56 of castLib 3, rect(30, 188, 57, 226)], [member 57 of castLib 3, rect(63, 189, 90, 227)], [member 58 of castLib 3, rect(130, 139, 154, 177)], [member 59 of castLib 3, rect(159, 139, 183, 177)], [member 60 of castLib 3, rect(123, 92, 151, 130)], [member 61 of castLib 3, rect(161, 93, 189, 131)], [member 62 of castLib 3, rect(57, 154, 77, 178)], [member 63 of castLib 3, rect(81, 155, 101, 179)], [member 64 of castLib 3, rect(206, 105, 231, 144)], [member 65 of castLib 3, rect(238, 104, 263, 143)], [member 66 of castLib 3, rect(120, 183, 154, 221)], [member 67 of castLib 3, rect(159, 184, 193, 222)], [member 68 of castLib 3, rect(210, 164, 240, 202)], [member 69 of castLib 3, rect(245, 164, 275, 202)], [member 70 of castLib 3, rect(51, 237, 76, 265)], [member 71 of castLib 3, rect(82, 238, 107, 266)], [member 72 of castLib 3, rect(206, 216, 234, 260)], [member 73 of castLib 3, rect(239, 216, 267, 249)], [member 74 of castLib 3, rect(222, 264, 240, 312)], [member 75 of castLib 3, rect(247, 263, 265, 311)], [member 76 of castLib 3, rect(122, 233, 152, 283)], [member 77 of castLib 3, rect(159, 234, 189, 284)], [member 78 of castLib 3, rect(27, 282, 67, 316)], [member 79 of castLib 3, rect(72, 281, 112, 315)], [member 80 of castLib 3, rect(194, 316, 225, 362)], [member 81 of castLib 3, rect(233, 317, 264, 363)], [member 82 of castLib 3, rect(125, 287, 152, 370)], [member 83 of castLib 3, rect(155, 286, 182, 369)], [member 84 of castLib 3, rect(48, 324, 74, 362)], [member 85 of castLib 3, rect(79, 325, 105, 363)]]
  DisplayStickerPage(lstStickers)
end

on ShowHair1
  set lstStickers to [[member 182 of castLib 3, rect(54, 141, 148, 208)], [member 183 of castLib 3, rect(49, 99, 165, 130)], [member 184 of castLib 3, rect(34, 210, 158, 271)], [member 185 of castLib 3, rect(164, 99, 273, 202)], [member 207 of castLib 3, rect(39, 276, 169, 361)], [member 206 of castLib 3, rect(182, 310, 272, 358)], [member 205 of castLib 3, rect(162, 210, 269, 304)]]
  DisplayStickerPage(lstStickers)
end

on ShowHair2
  set lstStickers to [[member 188 of castLib 3, rect(33, 113, 79, 215)], [member 189 of castLib 3, rect(97, 111, 143, 213)], [member 201 of castLib 3, rect(209, 121, 278, 202)], [member 200 of castLib 3, rect(129, 123, 206, 207)], [member 192 of castLib 3, rect(39, 226, 80, 286)], [member 190 of castLib 3, rect(157, 224, 203, 277)], [member 191 of castLib 3, rect(219, 225, 265, 278)], [member 194 of castLib 3, rect(44, 310, 117, 354)], [member 195 of castLib 3, rect(119, 311, 192, 355)], [member 193 of castLib 3, rect(84, 227, 125, 287)], [member 196 of castLib 3, rect(199, 293, 274, 334)]]
  DisplayStickerPage(lstStickers)
end

on ShowHair3
  set lstStickers to [[member 197 of castLib 3, rect(39, 187, 152, 215)], [member 198 of castLib 3, rect(154, 89, 201, 130)], [member 199 of castLib 3, rect(205, 89, 252, 130)], [member 187 of castLib 3, rect(46, 140, 137, 178)], [member 186 of castLib 3, rect(42, 88, 149, 133)], [member 210 of castLib 3, rect(150, 140, 208, 196)], [member 209 of castLib 3, rect(226, 242, 271, 298)], [member 208 of castLib 3, rect(41, 231, 132, 264)], [member 211 of castLib 3, rect(152, 215, 214, 265)], [member 212 of castLib 3, rect(210, 155, 236, 223)], [member 213 of castLib 3, rect(242, 154, 268, 222)], [member 215 of castLib 3, rect(120, 273, 175, 371)], [member 216 of castLib 3, rect(56, 273, 111, 371)], [member 214 of castLib 3, rect(228, 307, 265, 361)], [member 217 of castLib 3, rect(192, 289, 212, 329)]]
  DisplayStickerPage(lstStickers)
end

on ShowHair4
  set lstStickers to [[member 219 of castLib 3, rect(184, 301, 265, 355)], [member 202 of castLib 3, rect(40, 92, 214, 199)], [member 203 of castLib 3, rect(38, 205, 116, 291)], [member 204 of castLib 3, rect(121, 207, 196, 289)], [member 218 of castLib 3, rect(78, 295, 165, 375)], [member 223 of castLib 3, rect(243, 281, 248, 285)], [member 224 of castLib 3, rect(242, 242, 253, 253)], [member 225 of castLib 3, rect(232, 204, 261, 219)], [member 226 of castLib 3, rect(244, 183, 256, 197)], [member 227 of castLib 3, rect(234, 125, 249, 154)]]
  DisplayStickerPage(lstStickers)
end

on ShowBadges
  set lstStickers to [[member 228 of castLib 3, rect(199, 122, 257, 173)], [member 229 of castLib 3, rect(45, 220, 124, 288)], [member 230 of castLib 3, rect(55, 305, 118, 364)], [member 231 of castLib 3, rect(141, 183, 178, 213)], [member 232 of castLib 3, rect(148, 108, 197, 173)], [member 233 of castLib 3, rect(42, 94, 113, 179)], [member 234 of castLib 3, rect(180, 309, 223, 357)], [member 238 of castLib 3, rect(187, 200, 241, 253)], [member 241 of castLib 3, rect(134, 238, 208, 290)], [member 242 of castLib 3, rect(231, 176, 261, 202)], [member 243 of castLib 3, rect(33, 185, 104, 214)], [member 244 of castLib 3, rect(214, 257, 268, 286)], [member 245 of castLib 3, rect(118, 127, 147, 181)], [member 246 of castLib 3, rect(199, 89, 253, 118)], [member 247 of castLib 3, rect(239, 313, 268, 357)], [member 248 of castLib 3, rect(136, 303, 165, 374)]]
  DisplayStickerPage(lstStickers)
end

on ShowInsects
  set lstStickers to [[member 249 of castLib 3, rect(45, 129, 80, 162)], [member 250 of castLib 3, rect(181, 287, 260, 351)], [member 251 of castLib 3, rect(56, 298, 114, 365)], [member 252 of castLib 3, rect(34, 210, 102, 260)], [member 253 of castLib 3, rect(106, 89, 181, 149)], [member 254 of castLib 3, rect(95, 163, 167, 215)], [member 255 of castLib 3, rect(139, 336, 174, 368)], [member 265 of castLib 3, rect(186, 103, 276, 259)], [member 235 of castLib 3, rect(108, 249, 182, 305)]]
  DisplayStickerPage(lstStickers)
end

on ShowProps
  set lstStickers to [[member 268 of castLib 3, rect(219, 217, 268, 271)], [member 273 of castLib 3, rect(181, 177, 233, 226)], [member 274 of castLib 3, rect(125, 284, 169, 338)], [member 266 of castLib 3, rect(183, 271, 278, 363)], [member 264 of castLib 3, rect(88, 151, 193, 281)], [member 267 of castLib 3, rect(41, 108, 110, 181)], [member 269 of castLib 3, rect(35, 280, 102, 342)], [member 272 of castLib 3, rect(134, 96, 184, 139)], [member 271 of castLib 3, rect(98, 341, 175, 364)], [member 270 of castLib 3, rect(185, 92, 268, 178)], [member 263 of castLib 3, rect(38, 201, 75, 261)]]
  DisplayStickerPage(lstStickers)
end

on ShowHands
  set lstStickers to [[member 256 of castLib 3, rect(62, 84, 211, 154)], [member 257 of castLib 3, rect(26, 152, 175, 222)], [member 258 of castLib 3, rect(69, 213, 218, 283)], [member 261 of castLib 3, rect(170, 295, 221, 369)], [member 260 of castLib 3, rect(209, 91, 258, 208)], [member 262 of castLib 3, rect(34, 288, 148, 344)], [member 259 of castLib 3, rect(234, 196, 275, 367)]]
  DisplayStickerPage(lstStickers)
end

on ShowLetters
  set lstStickers to [[member 326 of castLib 3, rect(60, 96, 92, 110)], [member 327 of castLib 3, rect(113, 96, 142, 110)], [member 328 of castLib 3, rect(167, 96, 193, 110)], [member 329 of castLib 3, rect(219, 96, 249, 110)], [member 330 of castLib 3, rect(64, 146, 91, 160)], [member 331 of castLib 3, rect(115, 146, 142, 160)], [member 332 of castLib 3, rect(166, 145, 197, 161)], [member 333 of castLib 3, rect(219, 146, 251, 160)], [member 334 of castLib 3, rect(68, 187, 86, 201)], [member 335 of castLib 3, rect(118, 187, 139, 201)], [member 336 of castLib 3, rect(164, 187, 198, 201)], [member 337 of castLib 3, rect(222, 187, 249, 201)], [member 338 of castLib 3, rect(59, 227, 95, 241)], [member 339 of castLib 3, rect(111, 227, 145, 242)], [member 340 of castLib 3, rect(166, 227, 196, 241)], [member 341 of castLib 3, rect(220, 227, 250, 241)], [member 342 of castLib 3, rect(62, 267, 92, 285)], [member 343 of castLib 3, rect(112, 266, 144, 280)], [member 344 of castLib 3, rect(168, 266, 195, 281)], [member 345 of castLib 3, rect(220, 266, 250, 280)], [member 346 of castLib 3, rect(91, 305, 122, 320)], [member 347 of castLib 3, rect(142, 305, 172, 319)], [member 348 of castLib 3, rect(188, 305, 233, 319)], [member 349 of castLib 3, rect(89, 344, 124, 358)], [member 350 of castLib 3, rect(142, 344, 174, 358)], [member 351 of castLib 3, rect(193, 344, 227, 358)]]
  DisplayStickerPage(lstStickers)
end

on ShowNumbers
  set lstStickers to [[member 381 of castLib 3, rect(89, 96, 96, 116)], [member 382 of castLib 3, rect(141, 96, 154, 116)], [member 383 of castLib 3, rect(203, 96, 216, 116)], [member 384 of castLib 3, rect(85, 153, 99, 173)], [member 385 of castLib 3, rect(141, 153, 154, 173)], [member 386 of castLib 3, rect(203, 153, 216, 173)], [member 387 of castLib 3, rect(86, 197, 99, 217)], [member 388 of castLib 3, rect(141, 197, 154, 217)], [member 389 of castLib 3, rect(203, 197, 216, 217)], [member 390 of castLib 3, rect(141, 241, 154, 261)], [member 391 of castLib 3, rect(77, 336, 93, 356)], [member 392 of castLib 3, rect(207, 336, 220, 360)], [member 393 of castLib 3, rect(120, 284, 131, 304)], [member 394 of castLib 3, rect(82, 284, 86, 304)], [member 395 of castLib 3, rect(171, 283, 175, 303)], [member 396 of castLib 3, rect(208, 284, 219, 304)], [member 397 of castLib 3, rect(121, 350, 125, 354)], [member 398 of castLib 3, rect(168, 344, 176, 348)]]
  DisplayStickerPage(lstStickers)
end

on ShowBaldies
  set lstStickers to [[member 458 of castLib 3, rect(166, 333, 256, 370)], [member 459 of castLib 3, rect(51, 333, 143, 370)], [member 460 of castLib 3, rect(166, 291, 260, 328)], [member 461 of castLib 3, rect(53, 291, 143, 328)], [member 462 of castLib 3, rect(166, 248, 248, 274)], [member 463 of castLib 3, rect(53, 243, 143, 280)], [member 464 of castLib 3, rect(166, 205, 256, 242)], [member 465 of castLib 3, rect(56, 205, 143, 231)], [member 466 of castLib 3, rect(166, 154, 260, 191)], [member 467 of castLib 3, rect(49, 154, 143, 191)], [member 468 of castLib 3, rect(166, 103, 256, 140)], [member 469 of castLib 3, rect(53, 103, 143, 140)]]
  DisplayStickerPage(lstStickers)
end

on ShowFrames
  set lstStickers to [[member 275 of castLib 3, rect(55, 347, 251, 367)], [member 276 of castLib 3, rect(63, 128, 80, 333)], [member 277 of castLib 3, rect(38, 109, 56, 321)], [member 278 of castLib 3, rect(82, 322, 274, 347)], [member 281 of castLib 3, rect(85, 94, 268, 128)], [member 280 of castLib 3, rect(89, 136, 114, 280)], [member 282 of castLib 3, rect(242, 131, 269, 283)], [member 279 of castLib 3, rect(87, 287, 267, 315)]]
  DisplayStickerPage(lstStickers)
end

on PrevBody
  set gnBody to gnBody - 1
  if gnBody < 0 then
    set gnBody to MAX_BODIES - 1
  end if
  makemem()
  puppetSound(the name of cast (the number of member "FlagSound" + gnBody))
  set the castNum of sprite BODY_CH to the number of member "StartBody" + gnBody
  setAt(glstFace, Poster.Body, gnBody)
  updateStage()
end

on NextBody
  set gnBody to gnBody + 1
  if gnBody >= MAX_BODIES then
    set gnBody to 0
  end if
  makemem()
  set the castNum of sprite BODY_CH to the number of member "StartBody" + gnBody
  setAt(glstFace, Poster.Body, gnBody)
end

on PrevHEAD
  set gnHead to gnHead - 1
  if gnHead < 0 then
    set gnHead to MAX_HEADS - 1
  end if
  makemem()
  puppetSound(the name of cast (the number of member "HeadSound" + gnHead))
  set the castNum of sprite HEAD_CH to the number of member "StartHead" + gnHead
  setAt(glstFace, Poster.Head, gnHead)
  updateStage()
end

on NextHEAD
  set gnHead to gnHead + 1
  if gnHead >= MAX_HEADS then
    set gnHead to 0
  end if
  makemem()
  set the castNum of sprite HEAD_CH to the number of member "StartHead" + gnHead
  setAt(glstFace, Poster.Head, gnHead)
end

on PrevHAT
  set gnHat to gnHat - 1
  if gnHat < 0 then
    set gnHat to MAX_HATS - 1
  end if
  makemem()
  puppetSound(the name of cast (the number of member "HATSound" + gnHat))
  set the castNum of sprite HAT_CH to the number of member "StartHAT" + gnHat
  setAt(glstFace, Poster.Hat, gnHat)
  updateStage()
end

on NextHAT
  set gnHat to gnHat + 1
  if gnHat >= MAX_HATS then
    set gnHat to 0
  end if
  makemem()
  set the castNum of sprite HAT_CH to the number of member "StartHAT" + gnHat
  setAt(glstFace, Poster.Hat, gnHat)
end

on makemem
  if the freeBlock < 250000 then
    unLoadCast(4, 26)
    updateStage()
  end if
end

on CheckFlagHint
  if voidp(gbFlagHint) then
    set gbFlagHint to 1
    puppetSound(3, "sndFlagHint")
    return 1
  else
    return 0
  end if
end
